/* Lesson 14.10 Demo 3 - Apply Optimizer Hints */

-->>>>Join Hints are specified in the FROM clause of the query<<<<---------
--In the following, the first query employs the query optimizer.
--In the second query the join operation is performed by a HASH join 
--using a JOIN HINT
--INCLUDE THE ACTUAL EXECUTION PLAN (CTRL-M) 
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 
USE AdventureWorks2012;
GO
SELECT p.Name, pm.ProductModelID
 FROM Production.ProductModel AS pm
	LEFT OUTER JOIN Production.Product AS p
	ON pm.ProductModelID = p.ProductModelID
ORDER BY ProductModelID DESC;
GO

USE AdventureWorks2012;
GO
SELECT p.Name, pm.ProductModelID
 FROM Production.ProductModel AS pm
	LEFT OUTER HASH JOIN Production.Product AS p
	ON pm.ProductModelID = p.ProductModelID
ORDER BY ProductModelID DESC;
GO
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--In the following, the first query employs the query optimizer.
--In the second query the join operation is performed by a LOOP join 
--using a JOIN HINT
--INCLUDE THE ACTUAL EXECUTION PLAN (CTRL-M) 
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

USE AdventureWorks2012;
GO
SELECT p.Name, pm.ProductModelID
 FROM Production.ProductModel AS pm
	LEFT OUTER JOIN Production.Product AS p
	ON pm.ProductModelID = p.ProductModelID
ORDER BY ProductModelID DESC;
GO

USE AdventureWorks2012;
GO
SELECT p.Name, pm.ProductModelID
 FROM Production.ProductModel AS pm
	LEFT OUTER LOOP JOIN Production.Product AS p
	ON pm.ProductModelID = p.ProductModelID
ORDER BY ProductModelID DESC;
GO

 
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--In the following, the first query employs the query optimizer.
--In the second query the join operation is performed by a MERGE join 
--using a JOIN HINT
--INCLUDE THE ACTUAL EXECUTION PLAN (CTRL-M) 
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

USE AdventureWorks2012;
GO

SELECT d.Name, d.GroupName, edh.BusinessEntityID 
  FROM HumanResources.EmployeeDepartmentHistory AS edh
  INNER JOIN HumanResources.Department AS d 
      ON edh.DepartmentID = d.DepartmentID;
GO

USE AdventureWorks2012;
GO

SELECT d.Name, d.GroupName, edh.BusinessEntityID 
  FROM HumanResources.EmployeeDepartmentHistory AS edh
  INNER MERGE JOIN HumanResources.Department AS d 
      ON edh.DepartmentID = d.DepartmentID;
GO  
