/* Lesson 16.6 Demo 2 Compute an Aggregate Using a Cursor and Set-Based Solution */

USE AdventureWorks2012;
GO
/*
SELECT YEAR(orderdate) AS OrderYear, COUNT(*) AS NumOrders
	FROM Sales.SalesOrderHeader
	GROUP BY YEAR(orderdate);
GO
*/
CREATE TABLE #SOD ( SalesOrderDetailID INT, OrderQty smallint, RunningCount INT)

DECLARE @SalesOrderDetailID AS INT;
DECLARE @OrderQty AS smallint;  
DECLARE @RunningCount AS INT;
DECLARE @rc_cursor AS CURSOR;
 
SET @RunningCount = 0 

SET @rc_cursor =  CURSOR 
FOR 
SELECT SalesOrderDetailID, OrderQty 
FROM Sales.SalesOrderDetail;
OPEN @rc_cursor;
 
FETCH NEXT FROM @rc_cursor INTO @SalesOrderDetailID, @OrderQty

WHILE @@FETCH_STATUS = 0 
BEGIN 
	SET @RunningCount = @RunningCount + @OrderQty
	INSERT #SOD VALUES (@SalesOrderDetailID, @OrderQty, @RunningCount) 
	FETCH NEXT FROM @rc_cursor INTO @SalesOrderDetailID, @OrderQty;
END 

CLOSE @rc_cursor 
DEALLOCATE @rc_cursor 

SELECT * FROM #SOD ORDER BY OrderQty 

DROP TABLE #SOD;