/* Lesson 17 Implement Error Handling INLINE Code */

-->>>>>>Lesson 17.1 Implementing Try and Catch Blocks to Redirect Errors<<<<<-----
SET NOCOUNT ON
BEGIN TRY
	PRINT 'Start TRY Code Block'
	SELECT CAST('This is not an INT' AS INT)
	PRINT 'End of the TRY Block'
END TRY
BEGIN CATCH
	PRINT 'In the CATCH block because an error ocurred'
END CATCH;
GO

SET NOCOUNT ON
BEGIN TRY
	PRINT 'Start TRY Code Block'
	SELECT CAST('11' AS INT)
	PRINT 'End of the TRY Block'
END TRY
BEGIN CATCH
	PRINT 'In the CATCH block because an error ocurred'
END CATCH
GO

-->>>>>>Lesson 17.3 Using the Error Object Function to Return Detailed Error Information<<<<<<--
-->>>>>>This example produces an error - division by zero
-->>>>>>TRY block does not complete, and control transferred to the CATCH block
-->>>>>>NOTE: Error Object function relay the error and its description

USE AdventureWorks2012;
GO

BEGIN TRY
    UPDATE Production.Product
	SET ReorderPoint = ReorderPoint/0
		WHERE ProductID = 1;
	SELECT ReorderPoint
	FROM Production.Product
		WHERE ProductID = 1;
	PRINT 'Completing TRY block';
END TRY
BEGIN CATCH
    SELECT
        ERROR_NUMBER() AS ErrorNumber
        ,ERROR_SEVERITY() AS ErrorSeverity
        ,ERROR_STATE() AS ErrorState
        ,ERROR_PROCEDURE() AS ErrorProcedure
        ,ERROR_LINE() AS ErrorLine
        ,ERROR_MESSAGE() AS ErrorMessage;
END CATCH;
GO

-->>>>>>Lesson 17.6 Implementing EXACT_ABORT<<<<<<-------
USE AdventureWorks2012;
GO

DECLARE @XACT_ABORT VARCHAR(3) = 'OFF';
IF ( (16384 & @@OPTIONS) = 16384 ) SET @XACT_ABORT = 'ON';
SELECT @XACT_ABORT AS XACT_ABORT;

