/* Lesson 2.2 Demo 1 - Compare the CREATE VIEW Syntax with a Sample VIEW statement and Options */

--------------------------------------------------------------------------------------------------
/*
CREATE VIEW [ schema_name . ] view_name [ (column [ ,...n ] ) ] 
[ WITH <view_attribute> [ ,...n ] ] 
AS select_statement 
[ WITH CHECK OPTION ] 
[ ; ]

<view_attribute> ::= 
{
    [ ENCRYPTION ]
    [ SCHEMABINDING ]
    [ VIEW_METADATA ]     
} 
 */

USE AdventureWorks2012 ;
GO

CREATE VIEW HumanResources.vEmployeeHireDate
	WITH SCHEMABINDING
AS
SELECT p.FirstName, p.LastName, emp.HireDate
	FROM HumanResources.Employee AS emp
	 JOIN Person.Person AS  p
	ON emp.BusinessEntityID = p.BusinessEntityID;
GO

SELECT *
	FROM HumanResources.vEmployeeHireDate;
GO


   
