/* Lesson 3 INLINE Code */


--Lesson 3.3 Define and Create Unique Constraints------------------------------------
-->>>>>>>>>>>>>Uncomment code block to CREATE PRODUCTS TABLE if necessary >>>>>>>>>>>
/*
--Create the table Products in the Production schema of the CertData database -------
--Define PRIMARY KEY Constraint on ProductID using ALTER TABLE --
CREATE TABLE Production.Products
   (ProductID int  NOT NULL,
    ProductName varchar(50) NOT NULL,
	CategoryID INT NOT NULL,
    Price money NULL,
    ProductDescription varchar(max) NULL
	);
GO

ALTER TABLE Production.Products
 ADD CONSTRAINT PK_Products_ProductID PRIMARY KEY(ProductID);
GO
*/
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Using ALTER TABLE Create UNIQUE Constraint---------------------------------------
ALTER TABLE Production.Products
 ADD CONSTRAINT UQ_Products_ProductName UNIQUE(ProductName);
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Listing Constraints-------------------------------------------------------------
USE CertData
GO

SELECT *
FROM sys.key_constraints
WHERE type = 'UQ';
GO

SELECT * 
FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS 
WHERE CONSTRAINT_TYPE='UNIQUE'

SELECT *
FROM sys.key_constraints
WHERE type = 'PK';
GO
SELECT * 
FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS 
WHERE CONSTRAINT_TYPE='PRIMARY KEY'


-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Lessons 3.3 - 3.6 Adding Constraints---------------------------------------------
CREATE TABLE Production.ProductsNew
   (ProductID INT  NOT NULL,
    ProductName varchar(50) NOT NULL,
	CategoryID INT NOT NULL,
    Price money NULL,
    ProductDescription varchar(max) NULL
	CONSTRAINT PK_ProductsNew_ProductID PRIMARY KEY(ProductID),
	CONSTRAINT UQ_ProductsNEW_ProductName UNIQUE(ProductName),
	CONSTRAINT CHK_ProductNew_Price
	CHECK (Price>=0)
	);

DROP TABLE Production.ProductsNew;
GO

CREATE TABLE Production.ProductsNew
   (ProductID INT  NOT NULL,
    ProductName varchar(50) NOT NULL,
	CategoryID INT NOT NULL,
    Price money NOT NULL
	  CONSTRAINT DFT_ProductsNew_price DEFAULT(0),
    ProductDescription varchar(max) NULL
	CONSTRAINT PK_ProductsNew_ProductID PRIMARY KEY(ProductID),
	CONSTRAINT UQ_ProductsNEW_ProductName UNIQUE(ProductName),
	CONSTRAINT CHK_ProductNew_Price
	CHECK (Price>=0)
	);


SELECT *
FROM sys.default_constraints;
GO


SELECT * 
FROM sysobjects 
WHERE xtype = 'D';
GO
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Lesson 3.4 Define and Create Foreign Key Constraints-----------
USE CertData
GO

SELECT P.ProductName, C.CategoryName
 FROM Production.Products AS P
	JOIN Production.Categories AS C
		ON P.CategoryID = C.CategoryID
GO  
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--Lesson 3.6 Define and Create Default Constraints---------------
/*
The following example creates a table with two columns and inserts a value into the first column, and the other column remains NULL. 
A DEFAULT constraint is then added to the second column. 
To verify that the default is applied, another value is inserted into the first column, and the table is queried.
*/

CREATE TABLE dbo.doc_exz ( column_a INT, column_b INT) ;
GO
INSERT INTO dbo.doc_exz (column_a)VALUES ( 7 ) ;
GO
ALTER TABLE dbo.doc_exz
ADD CONSTRAINT col_b_def
DEFAULT 50 FOR column_b ;
GO
INSERT INTO dbo.doc_exz (column_a) VALUES ( 10 ) ;
GO
SELECT * FROM dbo.doc_exz ;
GO
DROP TABLE dbo.doc_exz ;
GO

