/* Lesson 6.6 Demo  - Use PIVOT and UNPIVOT Operators in Queries */

USE AdventureWorks2012 ;
GO

------Review Data from the Production.Product table---------------
SELECT Name, DaysToManufacture,StandardCost
FROM Production.Product

SELECT Name, DaysToManufacture,AVG(StandardCost) AS AverageCost
FROM Production.Product
GROUP BY Name, DaysToManufacture


SELECT DaysToManufacture, AVG(StandardCost) AS AverageCost 
FROM Production.Product
GROUP BY DaysToManufacture;


-->>>>>>>>>>>>>>>>PIVOT table>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-- Pivot table with one row and five columns
SELECT 'AverageCost' AS Cost_Sorted_By_Production_Days, 
[0], [1], [2], [3], [4]
FROM
(SELECT DaysToManufacture, StandardCost 
    FROM Production.Product) AS SourceTable
PIVOT
(
AVG(StandardCost)
FOR DaysToManufacture IN ([0], [1], [2], [3], [4])
) AS PivotTable;

-->>>>>>>>>>>>>>>>>>>>UNPIVOT table>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
USE tempdb
GO

DECLARE @p TABLE
(    
  col1 int,
  col2 int,
  col3 int,
  col4 int,
  col5 int
)  

INSERT INTO @p
SELECT 1,2,3,4,5

Select * 
FROM @p


----->Now to UNPIVOT the table<-----------------------------------
SELECT
  unpvt.ColName,
  unpvt.ColValue
FROM 
(
SELECT col1, col2, col3, col4, col5
FROM @p
) p
UNPIVOT (ColValue FOR ColName IN (col1, col2, col3, col4, col5) ) AS unpvt;


