/* Lesson 9.4 Demo 2 - Use XQUERY to Extract Data*/

-----------------------------------------------------
-- Using Sequences-----------------------------------
-----------------------------------------------------
DECLARE @x AS XML;
SET @x=N'
<root>
	<a>10<b>20</b><c>30</c></a>
	<d>40</d><e>50</e>
</root>';
SELECT 
	@x.query('*') AS Complete_Sequence,
	@x.query('data(*)') AS Complete_Data,
	@x.query('data(root/a/b)') AS Element_b_Data,
	@x.query('data(root/a/c)') AS Element_c_Data,
	@x.query('data(root/e)') AS Element_e_Data;
GO


-----------------------------------------------------
-- Using XQUERY Functions---------------------------
--Track the first order and the last order from the input XML
-----------------------------------------------------
DECLARE @x AS XML;
SET @x='
<CustomersOrders>
  <Customer CustomerID="29734" StoreID="852">
    <Orders SalesOrderID="43661" OrderDate="2005-07-01" SalesTotal="32,726.48" />
    <Orders SalesOrderID="44282" OrderDate="2005-10-01" SalesTotal="40,341.11" />
    <Orders SalesOrderID="45038" OrderDate="2006-01-01" SalesTotal="27,123.65" />
    <Orders SalesOrderID="45780" OrderDate="2006-04-01" SalesTotal="31,193.32" />
  </Customer>
  <Customer CustomerID="29825" StoreID="1046">
    <Orders SalesOrderID="43659" OrderDate="2005-07-01" SalesTotal="20,565.62" />
    <Orders SalesOrderID="44305" OrderDate="2005-10-01" SalesTotal="18,880.65" />
    <Orders SalesOrderID="45061" OrderDate="2006-01-01" SalesTotal="73,261.15" />
    <Orders SalesOrderID="45779" OrderDate="2006-04-01" SalesTotal="18,031.60" />
  </Customer>
</CustomersOrders>';
SELECT @x.query
('
for $custnode in //Customer
return
   <OrderTracking>
      { $custnode/@CustomerID }
      <NumberOfOrders>
		  { count($custnode/Orders) }
      </NumberOfOrders>
	  <FirstOrder>
		  { min($custnode/Orders/@SalesOrderID) }
	  </FirstOrder>
      <LastOrder>
		  { max($custnode/Orders/@SalesOrderID) }
	  </LastOrder>
   </OrderTracking>
');
GO

-----------------------------------------------------
-- Using XQUERY Value Comparison Operators-----------
-----------------------------------------------------
DECLARE @xvar AS XML = N'';				
SELECT @xvar.query('(5) lt (10)');
SELECT @xvar.query('(5) gt (10)');
SELECT @xvar.query('(10) eq 10');			
SELECT @xvar.query('(10) ne 10')
GO
